## [PureMVC](http://puremvc.github.com/) ActionScript 3 Standard Framework
PureMVC is a lightweight framework for creating applications based upon the classic [Model-View-Controller](http://en.wikipedia.org/wiki/Model-view-controller) design meta-pattern. This is the specific implementation for the AS3 language, and the reference implementation for [all other PureMVC Ports](http://puremvc.github.com/). It does not support [modular programming](http://en.wikipedia.org/wiki/Modular_programming) since it uses [Singleton](http://en.wikipedia.org/wiki/Singleton_pattern)s as Core actors rather than the [Multiton](http://en.wikipedia.org/wiki/Multiton)s used in the [MultiCore](https://github.com/PureMVC/puremvc-as3-multicore-framework/wiki/) Version.

* [API Docs](http://darkstar.puremvc.org/content_header.html?url=http://puremvc.org/pages/docs/AS3/standard/framework_asdoc/&desc=PureMVC%20API%20Docs:%20PureMVC%20Standard%20for%20ActionScript%203)
* [Unit Tests](https://github.com/PureMVC/puremvc-as3-standard-unittests/wiki)
* [Discussion](http://forums.puremvc.org/index.php?board=26.0)
* [Standard Version Overview Presentation](http://puremvc.tv/#P100)
* [ActionScript Developer's Guide to PureMVC (O'Reilly)](http://oreil.ly/puremvc)

## Demos
* For FLEX
  * [App Skeleton](https://github.com/PureMVC/puremvc-as3-demo-flex-appskeleton/wiki)
  * [Bookstore](https://github.com/PureMVC/puremvc-as3-demo-flex-weborb-bookstore/wiki)
  * [Cafe Townsend](https://github.com/PureMVC/puremvc-as3-demo-flex-cafetownsend/wiki)
  * [Employee Admin](https://github.com/PureMVC/puremvc-as3-demo-flex-employeeadmin/wiki)
  * [File Upload](https://github.com/PureMVC/puremvc-as3-demo-flex-cf-fileupload/wiki)
  * [History Panel](https://github.com/PureMVC/puremvc-as3-demo-flex-historypanel/wiki)
  * [Index Cards](https://github.com/PureMVC/puremvc-as3-demo-flex-rails-indexcards/wiki)
  * [Loadup as Ordered](https://github.com/PureMVC/puremvc-as3-demo-flex-loadupasordered/wiki)
  * [Loadup for Assets](https://github.com/PureMVC/puremvc-as3-demo-flex-loadupforassets/wiki)
  * [Manifold Roamer](https://github.com/PureMVC/puremvc-as3-demo-flex-manifoldroamer/wiki)
  * [Login](https://github.com/PureMVC/puremvc-as3-demo-flex-weborb-login/wiki)
  * [Slacker](https://github.com/PureMVC/puremvc-as3-demo-flex-slacker/wiki)
  * [Query CFC](https://github.com/PureMVC/puremvc-as3-demo-flex-cf-querycfc/wiki)
  * [StopWatch](https://github.com/PureMVC/puremvc-as3-demo-flex-stopwatch/wiki)
* For AIR
  * [CodePeek](https://github.com/PureMVC/puremvc-as3-demo-air-codepeek/wiki)
  * [HelloPlaybook](https://github.com/PureMVC/puremvc-as3-demo-air-helloplaybook/wiki)
  * [RSS Headlines](https://github.com/PureMVC/puremvc-as3-demo-air-rssheadlines/wiki)
* For FLASH
  * [Hello Flash](https://github.com/PureMVC/puremvc-as3-demo-flash-helloflash/wiki)
  * [Sequential](https://github.com/PureMVC/puremvc-as3-demo-flash-sequential/wiki)

## Utilities
* For FLEX, FLASH, or AIR
  * [Async Command](https://github.com/PureMVC/puremvc-as3-util-asynccommand/wiki)
  * [Async Stub](https://github.com/PureMVC/puremvc-as3-util-asyncstub/wiki)
  * [Loadup](https://github.com/PureMVC/puremvc-as3-util-loadup/wiki)
  * [State Machine](https://github.com/PureMVC/puremvc-as3-util-statemachine/wiki)
  * [Undo](https://github.com/PureMVC/puremvc-as3-util-undo/wiki)
* For FLEX or AIR
  * [Deployment Config](https://github.com/PureMVC/puremvc-as3-util-flex-deploymentconfig/wiki)
* For AIR
  * [Desktop Citizen](https://github.com/PureMVC/puremvc-as3-util-air-desktopcitizen/wiki) 
  * [XML Database](https://github.com/PureMVC/puremvc-as3-util-air-xmldatabase/wiki) 

## Status
Production - [Version 2.0.4](https://github.com/PureMVC/puremvc-as3-standard-framework/blob/master/VERSION)

## Platforms / Technologies
* [ActionScript 3](http://en.wikipedia.org/wiki/ActionScript)
* [Flex](http://en.wikipedia.org/wiki/Adobe_flash)
* [Flash](http://en.wikipedia.org/wiki/Adobe_Flex)
* [AIR](http://en.wikipedia.org/wiki/Adobe_Air)

## License
* PureMVC AS3 Standard Framework - Copyright © 2006-2012 Futurescale, Inc.
* All rights reserved.

* Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
  * Neither the name of Futurescale, Inc., PureMVC.org, nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.